﻿Type=Activity
Version=3.82
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private Node_Height As Int = 25dip
	Private Node_Width As Int = 15dip
	Private Node_Margin_X As Int = 3dip
	Private Node_Margin_Y As Int = 20dip
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim Data As List
	Dim DataTree As Tree
	Dim Panel2 As Panel
	Dim g1 As Gestures
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	Dim DrawTreeObj As DrawTree
	
	Panel2.Initialize("Pnl")
	Activity.AddView(Panel2,0%x,0%y,50%x,50%y)
	Panel2.LoadLayout("Test")
	Data = GetData
	DataTree = GetRootTree(Data)
	DrawTreeObj.Initialize
	DrawTreeObj.CalculateNodePositions(DataTree)	
	CalculateControlSize(DataTree)
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
Sub GetData() As List
	Dim tempList As List
	tempList.Initialize
	tempList.Add("1~~73~Pratapchand")
	tempList.Add("2~1~74~Meghraj")
	tempList.Add("3~1~75~Chunilal")
	tempList.Add("4~1~76~Ghisulal")
	tempList.Add("5~1~77~Raichand")
	tempList.Add("6~1~78~Mohan")
	tempList.Add("7~2~79~Madan")
	tempList.Add("8~2~80~Suresh")
	tempList.Add("9~2~81~Raju")
	tempList.Add("10~2~82~Ashok")

	
	Return tempList
	'tempList.c
	
	
End Sub
Sub GetRootTree(TempData As List) As Tree 
	Dim ID, ParentID, Name, SpouseID, TreeValues() As String
	Dim Root, Parent As Tree	
	
	TreeValues = Regex.Split("~",TempData.Get(0))
	ID = TreeValues(0)
	ParentID = TreeValues(1)
	SpouseID = TreeValues(2)
	Name = TreeValues(3)
	
	Root.Initialize(ID)
	Root.Name = Name
	Root.AddParent(Null)
	Root.SpouseID = SpouseID
	'Root.IsRoot = True
	Root.AddChildren(GetChildren(TempData, Root))
	
	Return Root
	
End Sub
Public Sub GetChildren(TempData As List, Parent As Tree) As List
	Dim ID, ParentID, Name, SpouseID, TreeValues() As String
	Dim NodeList As List
	NodeList.Initialize
	
	For i = 0 To TempData.Size - 1	
		TreeValues = Regex.Split("~",TempData.Get(i))
		ID = TreeValues(0)
		ParentID = TreeValues(1)
		SpouseID = TreeValues(2)
		Name = TreeValues(3)
		
		'If ParentID = Parent.ID Then
		If ParentID = Parent.ID Then
			Dim TreeNode As Tree
			'Dim TreeNode, ParentNode As Tree
			TreeNode.Initialize(ID)
			'ParentNode.Initialize(ParentID)
			TreeNode.AddParent (Parent)
			'TreeNode.Name = Name
			TreeNode.Name = Name
			TreeNode.SpouseID = SpouseID
			'TreeNode.Children = GetChildren(TempData, TreeNode)
			TreeNode.Children = GetChildren(TempData, TreeNode)
			NodeList.Add(TreeNode)
		End If		
	Next	
	Return NodeList
End Sub
Sub DrawNode(Node As Tree, Cvs As Canvas, ParentPnl As Panel)
	Dim NodeRect, ImageRect,SpouseRect As Rect
	Dim Rectx, RectY
	Dim Text As String
	Dim Image As Bitmap
	'Dim ImageView1 As ImageView
	Dim Scale As Float = GetDeviceLayoutValues.Scale
	Dim Pnl As Panel
	Pnl.Initialize("Click")
	
	Image.Initialize(File.DirAssets,"sallu.gif")
	'ImageView1.Bitmap = Image
	
	Rectx = Node_Margin_X + (Node.X * (Node_Width + Node_Margin_X))	
	RectY = Node_Margin_Y + (Node.Y * (Node_Height + Node_Margin_Y))		
	Node.X1 = Rectx
	Node.Y1 = RectY	
	If Node.HasSpouse Then 		
		Node.SpouseX1 = Rectx-Node_Width
		Node.SpouseY1 = RectY
		Node.SpouseX2 = Rectx
		Node.SpouseY2 = RectY + Node_Height
		SpouseRect.Initialize(Node.SpouseX1, Node.SpouseY1 ,Node.SpouseX2, Node.SpouseY2)		
		'the following will store values in pixels
		Node.SpouseX1 = Scale * Node.SpouseX1
		Node.SpouseY1 = Scale * Node.SpouseY1
		Node.SpouseX2 = Scale * Node.SpouseX2
		Node.SpouseY2 = Scale * Node.SpouseY2
		Cvs.DrawRect(SpouseRect, Colors.White,False, 1dip)				
	End If
	Node.X2 = Rectx + Node_Width
	Node.Y2 = RectY + Node_Height
	NodeRect.Initialize(Node.X1, Node.Y1, Node.X2, Node.Y2)		
	ParentPnl.AddView(Pnl,Node.X1,Node.Y1,Node.X2 - Node.X1,Node.Y2 - Node.Y1)
	Pnl.Color = Colors.Cyan	
	
	'NodeRect.Initialize(10dip, 10dip, 110dip, 110dip)
	'the following will store values in pixels
	Node.X1 = Scale * Node.X1
	Node.Y1 = Scale * Node.Y1
	Node.X2 = Scale * Node.X2
	Node.Y2 = Scale * Node.Y2
	'ImageRect.Initialize(RectX, RectY, RectX + Node_Width, RectY + Node_Height - 6dip)
	
	Cvs.DrawRect(NodeRect, Colors.Gray,False, 1dip)
	
	'Cvs.DrawBitmap(Image,Null,ImageRect)
	
	'draw text (name)
	Text = NumberFormat(Node.X,0,2)
	Cvs.DrawText(Node.ID, NodeRect.Left + 6, NodeRect.Top + 40,Typeface.DEFAULT,8, Colors.Yellow,"LEFT")
	Cvs.DrawText(Text, NodeRect.Left + 4, NodeRect.Top + 70,Typeface.DEFAULT,8, Colors.Yellow,"LEFT")
	
	'// draw line To parent
	If Node.Parent <> Null Then
		Dim nodeTopMiddle As Float '= NodeRect.Left + (NodeRect.Right - NodeRect.Left) / 2
		If Node.HasSpouse Then
			nodeTopMiddle = SpouseRect.Left + (SpouseRect.Right - SpouseRect.Left) / 2
		Else
			nodeTopMiddle = NodeRect.Left + (NodeRect.Right - NodeRect.Left) / 2
		End If		
		Cvs.DrawLine(nodeTopMiddle,NodeRect.Top,nodeTopMiddle, NodeRect.Top - (Node_Margin_Y / 2),Colors.yellow,1dip)
	End If	
	
'draw line to children
	If Node.Children.Size > 0 Then
		Dim nodeBottomMiddleX As Float = NodeRect.Left '+ (NodeRect.Right - NodeRect.Left) / 2
		Dim nodeBottomMiddleY As Float = NodeRect.Top + NodeRect.Bottom - NodeRect.Top
		
		Cvs.DrawLine(nodeBottomMiddleX,nodeBottomMiddleY, nodeBottomMiddleX, nodeBottomMiddleY + (Node_Margin_Y/2),Colors.Red, 1dip)
		Dim RightChild, LeftChild As Tree
		'// draw line over children
		If Node.Children.Size = 1 Then
			LeftChild = Node.Children.Get(0)			
			If LeftChild.HasSpouse Then
				Cvs.DrawLine(NodeRect.Left, NodeRect.Bottom + (Node_Margin_Y / 2) , SpouseRect.CenterX, NodeRect.Bottom + (Node_Margin_Y / 2),Colors.Green, 1Dip)	
			Else
				Cvs.DrawLine(NodeRect.Left, NodeRect.Bottom + (Node_Margin_Y / 2) , NodeRect.CenterX, NodeRect.Bottom + (Node_Margin_Y / 2),Colors.Green, 1Dip)	
			End If
			
		Else If Node.Children.Size > 1 Then
			Dim LineStartX, LineStartY, LineEndX, LineEndY As Float
			
			LeftChild = Node.GetLeftMostChild
			RightChild = Node.GetRightMostChild
			LineStartX = Node_Margin_X + (Node.GetRightMostChild.X * (Node_Width + Node_Margin_X)) + (Node_Width / 2)
			If RightChild.HasSpouse Then
				LineStartX = LineStartX - Node_Width		
			End If
			LineStartY = nodeBottomMiddleY + (Node_Margin_Y / 2)
			
			LineEndX = Node_Margin_X + (Node.GetLeftMostChild.X * (Node_Width + Node_Margin_X)) + (Node_Width / 2)
			If LeftChild.HasSpouse Then
				LineEndX = LineEndX - Node_Width		
			End If
			LineEndY = nodeBottomMiddleY + (Node_Margin_Y / 2)
			
			Cvs.DrawLine(LineStartX,LineStartY,	LineEndX, LineEndY,Colors.Green, 1Dip)			
		End If		
	End If	
	
	For Each item In Node.Children
		DrawNode(item,Cvs,ParentPnl)
	Next	
End Sub
Sub CalculateControlSize(Node As Tree)
	'// Tree sizes are 0-based, so add 1
	
	Dim treeWidth As Float = Node.Width + 1
	Dim treeHeight As Float = Node.Height + 1
	'Dim bmpHeight, bmpWidth As Float
	
	Dim bmp As Bitmap
	'Dim l1 As l
	
	Panel2.Height = treeHeight * Node_Height + (treeHeight + 1)* Node_Margin_Y
	Panel2.Width = treeWidth * Node_Width + (treeWidth + 1)* Node_Margin_X	
	
	bmp.InitializeMutable(Panel2.Width,Panel2.Height)

	Dim Cvs As Canvas
	Cvs.Initialize(Panel2)
  'Cvs.Initialize2(bmp)
	DrawNode(Node, Cvs, Panel2)
	'Panel2.SetBackgroundImage(bmp)

	Panel2.Invalidate
	Dim Pz As PinchZoomAndMove
	Dim c As Int
	Pz.Initialize(Panel2,"PZ",c,0.5,5,20,False,Me)
	
End Sub
